Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14398)
@@ -1,30 +1,42 @@
 ﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class LoopExpression : Expression
+    public abstract class LoopExpression : StatefullExpression
     {
-        public long destinationIndex;
-        public long currentIndex;
-        public long incrementor;
-        public bool pushCurrentIndex = false;
-        public Expression body;
+        protected long destinationIndex;
+        protected long currentIndex;
+        protected long incrementor;
+        protected Expression body;
 
-        public LoopExpression(string stringRepresentation) : base(stringRepresentation) { }
+        public LoopExpression()
+        { }
 
-        protected void Eval(IInterpreter interpreter, IStack<Expression> sourceStack)
+        /// <summary>
+        /// Clone constructor
+        /// </summary>
+        protected LoopExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
+        {
+            destinationIndex = origin.destinationIndex;
+            currentIndex = origin.currentIndex;
+            incrementor = origin.incrementor;
+            body = origin.body;
+        }
+
+        protected void Eval(IInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false)
         {
             // if not initialized
             if (body == null)
             {
-                if (this.HasInsufficientArguments(interpreter, sourceStack))
+                if (HasInsufficientArguments(interpreter, sourceStack))
                 {
                     return;
                 }
 
-                this.InitState(interpreter, sourceStack);
+                InitState(interpreter, sourceStack);
 
-                interpreter.ExecStack.Push(this, this.body);
+                interpreter.ExecStack.Push(this, body);
 
                 return;
@@ -34,29 +46,29 @@
             if (destinationIndex == currentIndex)
             {
-                this.PushLastIteration(interpreter);
-                this.Clear();
+                PushLastIteration(interpreter);
+                Clear();
 
                 return;
             }
 
-            this.PushIteration(interpreter);
-            this.currentIndex += this.incrementor;
+            PushIteration(interpreter);
+            currentIndex += incrementor;
         }
 
         protected virtual void Clear()
         {
-            this.body = null;
+            body = null;
         }
 
         protected virtual void PushIteration(IInterpreter interpreter)
         {
-            interpreter.IntegerStack.Push(this.currentIndex);
-            interpreter.ExecStack.Push(this, this.body);
+            interpreter.IntegerStack.Push(currentIndex);
+            interpreter.ExecStack.Push(this, body);
         }
 
         protected virtual void PushLastIteration(IInterpreter interpreter)
         {
-            interpreter.IntegerStack.Push(this.currentIndex);
-            interpreter.ExecStack.Push(this.body);
+            interpreter.IntegerStack.Push(currentIndex);
+            interpreter.ExecStack.Push(body);
         }
 
@@ -71,11 +83,35 @@
 
             var isBodyEqual =
-                (this.body == null && other.body == null) ||
-                (this.body != null && other.body != null && this.body.Equals(other.body));
+                (body == null && other.body == null) ||
+                (body != null && other.body != null && body.Equals(other.body));
 
             return isBodyEqual &&
-                this.currentIndex == other.currentIndex &&
-                this.destinationIndex == other.destinationIndex &&
-                this.incrementor == other.incrementor;
+                currentIndex == other.currentIndex &&
+                destinationIndex == other.destinationIndex &&
+                incrementor == other.incrementor;
+        }
+
+        public override int GetHashCode()
+        {
+            return base.GetHashCode();
+        }
+
+        protected override int InitId()
+        {
+            unchecked
+            {
+                var hash = 19;
+
+                if (body != null)
+                {
+                    hash *= 31 + body.GetHashCode();
+                }
+
+                hash *= 31 + currentIndex.GetHashCode();
+                hash *= 31 + destinationIndex.GetHashCode();
+                hash *= 31 + incrementor.GetHashCode();
+
+                return hash;
+            }
         }
 
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14398)
@@ -1,4 +1,6 @@
-﻿using System.Linq;
+﻿using System;
+using System.Linq;
 using HeuristicLab.Algorithms.PushGP.Interpreter;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Random;
@@ -6,7 +8,16 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public class NameDefineXExecExpression : Expression
+    public class NameDefineXExecExpression : StatefullExpression
     {
-        public NameDefineXExecExpression(string name) : base(name) { }
+        private readonly string name;
+        public NameDefineXExecExpression(string name)
+        {
+            this.name = name;
+        }
+
+        public NameDefineXExecExpression(NameDefineXExecExpression origin, Cloner cloner) : base(origin, cloner)
+        {
+            name = origin.name;
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -14,5 +25,5 @@
             Expression expression;
             if (!interpreter.IsNameQuoteFlagSet &&
-                interpreter.CustomExpressions.TryGetValue(this.StringRepresentation, out expression))
+                interpreter.CustomExpressions.TryGetValue(name, out expression))
             {
                 interpreter.ExecStack.Push(expression);
@@ -20,5 +31,5 @@
             else
             {
-                interpreter.NameStack.Push(this.StringRepresentation);
+                interpreter.NameStack.Push(name);
                 interpreter.IsNameQuoteFlagSet = false;
             }
@@ -32,5 +43,27 @@
             }
 
-            return this.StringRepresentation.Equals(obj.ToString());
+            var other = obj as NameDefineXExecExpression;
+
+            return name.Equals(other.name);
+        }
+
+        public override int GetHashCode()
+        {
+            return base.GetHashCode();
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return name;
+        }
+
+        protected override int InitId()
+        {
+            return name.GetHashCode();
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            throw new NotImplementedException();
         }
     }
@@ -41,7 +74,10 @@
     /// onto the NAME stack the flag will be cleared (whether or not the pushed name had a definition).
     /// </summary>
-    public class NameQuoteExpression : Expression
+    public class NameQuoteExpression : StatelessExpression
     {
-        public NameQuoteExpression() : base("NAME.QUOTE") { }
+        protected override string InitStringRepresentation()
+        {
+            return "NAME.QUOTE";
+        }
 
         public override void Eval(IInterpreter interpreter)
@@ -54,9 +90,12 @@
     /// Pushes a randomly selected NAME that already has a definition.
     /// </summary>
-    public class NameRandBoundNameExpression : Expression
+    public class NameRandBoundNameExpression : StatelessExpression
     {
         private static IRandom rand = new FastRandom();
 
-        public NameRandBoundNameExpression() : base("NAME.RANDBOUNDNAME") { }
+        protected override string InitStringRepresentation()
+        {
+            return "NAME.RANDBOUNDNAME";
+        }
 
         public override void Eval(IInterpreter interpreter)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14398)
@@ -4,10 +4,6 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class PopExpression<T> : Expression
+    public abstract class PopExpression<T> : StatelessExpression
     {
-        public PopExpression(string stringRepresentation) : base(stringRepresentation)
-        {
-        }
-
         public void Eval(IStack<T> stack)
         {
@@ -21,11 +17,9 @@
     public class IntegerPopExpression : PopExpression<long>
     {
-        public IntegerPopExpression() : base("INTEGER.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "INTEGER.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
     }
@@ -33,11 +27,9 @@
     public class FloatPopExpression : PopExpression<double>
     {
-        public FloatPopExpression() : base("FLOAT.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "FLOAT.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
     }
@@ -45,11 +37,9 @@
     public class BooleanPopExpression : PopExpression<bool>
     {
-        public BooleanPopExpression() : base("BOOLEAN.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "BOOLEAN.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
     }
@@ -57,11 +47,9 @@
     public class NamePopExpression : PopExpression<string>
     {
-        public NamePopExpression() : base("NAME.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "NAME.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
     }
@@ -69,11 +57,9 @@
     public class ExecPopExpression : PopExpression<Expression>
     {
-        public ExecPopExpression() : base("EXEC.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "EXEC.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack);
+            Eval(interpreter.ExecStack);
         }
     }
@@ -81,11 +67,9 @@
     public class CodePopExpression : PopExpression<Expression>
     {
-        public CodePopExpression() : base("CODE.POP")
-        {
-        }
+        protected override string InitStringRepresentation() { return "CODE.POP"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack);
+            Eval(interpreter.CodeStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14398)
@@ -5,9 +5,9 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class PushExpression<T> : Expression
+    public abstract class PushExpression<T> : StatefullExpression
     {
         protected readonly T value;
 
-        public PushExpression(T value) : base(value.ToString(), value.GetHashCode())
+        public PushExpression(T value)
         {
             this.value = value;
@@ -17,10 +17,20 @@
         public PushExpression(PushExpression<T> expression, Cloner cloner) : base(expression, cloner)
         {
-            this.value = expression.value;
+            value = expression.value;
+        }
+
+        protected override int InitId()
+        {
+            return this.value.GetHashCode();
+        }
+
+        protected override string InitStringRepresentation()
+        {
+            return this.value.ToString();
         }
 
         protected void Eval(IStack<T> stack)
         {
-            stack.Push(this.value);
+            stack.Push(value);
         }
 
@@ -34,5 +44,10 @@
             var other = obj as PushExpression<T>;
 
-            return this.value.Equals(value);
+            return value.Equals(value);
+        }
+
+        public override int GetHashCode()
+        {
+            return base.GetHashCode();
         }
     }
@@ -49,5 +64,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
 
@@ -69,5 +84,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
 
@@ -89,5 +104,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
 
@@ -109,5 +124,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
 
@@ -129,5 +144,5 @@
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack);
+            Eval(interpreter.ExecStack);
         }
 
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14398)
@@ -4,9 +4,6 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class PushResultExpression<T> : Expression
+    public abstract class PushResultExpression<T> : StatelessExpression
     {
-        public PushResultExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc)
         {
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14398)
@@ -7,9 +7,7 @@
     /// Pushes a random NAME.
     /// </summary>
-    public class NameRandExpression : Expression
+    public class NameRandExpression : StatelessExpression
     {
-        public NameRandExpression() : base("NAME.RAND")
-        {
-        }
+        protected override string InitStringRepresentation() { return "NAME.RAND"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -24,9 +22,7 @@
     /// Pushes a random integer.
     /// </summary>
-    public class IntegerRandExpression : Expression
+    public class IntegerRandExpression : StatelessExpression
     {
-        public IntegerRandExpression() : base("INTEGER.RAND")
-        {
-        }
+        protected override string InitStringRepresentation() { return "INTEGER.RAND"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -43,9 +39,7 @@
     /// Pushes a random float.
     /// </summary>
-    public class FloatRandExpression : Expression
+    public class FloatRandExpression : StatelessExpression
     {
-        public FloatRandExpression() : base("FLOAT.RAND")
-        {
-        }
+        protected override string InitStringRepresentation() { return "FLOAT.RAND"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -62,9 +56,7 @@
     /// Pushes a random boolean.
     /// </summary>
-    public class BooleanRandExpression : Expression
+    public class BooleanRandExpression : StatelessExpression
     {
-        public BooleanRandExpression() : base("BOOLEAN.RAND")
-        {
-        }
+        protected override string InitStringRepresentation() { return "BOOLEAN.RAND"; }
 
         public override void Eval(IInterpreter interpreter)
@@ -79,9 +71,7 @@
     /// Pushes random expressions onto the code stack.
     /// </summary>
-    public class CodeRandExpression : Expression
+    public class CodeRandExpression : StatelessExpression
     {
-        public CodeRandExpression() : base("CODE.RAND")
-        {
-        }
+        protected override string InitStringRepresentation() { return "CODE.RAND"; }
 
         public override void Eval(IInterpreter interpreter)
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14398)
@@ -4,9 +4,6 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class RotateExpression<T> : Expression
+    public abstract class RotateExpression<T> : StatelessExpression
     {
-        public RotateExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack)
         {
@@ -20,10 +17,9 @@
     public class IntegerRotateExpression : RotateExpression<long>
     {
-        public IntegerRotateExpression() : base("INTEGER.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack);
+            Eval(interpreter.IntegerStack);
         }
     }
@@ -31,10 +27,9 @@
     public class FloatRotateExpression : RotateExpression<double>
     {
-        public FloatRotateExpression() : base("FLOAT.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack);
+            Eval(interpreter.FloatStack);
         }
     }
@@ -42,10 +37,9 @@
     public class BooleanRotateExpression : RotateExpression<bool>
     {
-        public BooleanRotateExpression() : base("BOOLEAN.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack);
+            Eval(interpreter.BooleanStack);
         }
     }
@@ -53,10 +47,9 @@
     public class NameRotateExpression : RotateExpression<string>
     {
-        public NameRotateExpression() : base("NAME.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack);
+            Eval(interpreter.NameStack);
         }
     }
@@ -64,10 +57,9 @@
     public class ExecRotateExpression : RotateExpression<Expression>
     {
-        public ExecRotateExpression() : base("EXEC.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack);
+            Eval(interpreter.ExecStack);
         }
     }
@@ -75,10 +67,9 @@
     public class CodeRotateExpression : RotateExpression<Expression>
     {
-        public CodeRotateExpression() : base("CODE.ROT")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.ROT"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack);
+            Eval(interpreter.CodeStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14398)
@@ -4,9 +4,6 @@
 namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-    public abstract class ShoveExpression<T> : Expression
+    public abstract class ShoveExpression<T> : StatelessExpression
     {
-        public ShoveExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
         {
@@ -29,10 +26,9 @@
     public class IntegerShoveExpression : ShoveExpression<long>
     {
-        public IntegerShoveExpression() : base("INTEGER.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+            Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
         }
     }
@@ -40,10 +36,9 @@
     public class FloatShoveExpression : ShoveExpression<double>
     {
-        public FloatShoveExpression() : base("FLOAT.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+            Eval(interpreter.FloatStack, interpreter.IntegerStack);
         }
     }
@@ -51,10 +46,9 @@
     public class BooleanShoveExpression : ShoveExpression<bool>
     {
-        public BooleanShoveExpression() : base("BOOLEAN.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
         }
     }
@@ -62,10 +56,9 @@
     public class NameShoveExpression : ShoveExpression<string>
     {
-        public NameShoveExpression() : base("NAME.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+            Eval(interpreter.NameStack, interpreter.IntegerStack);
         }
     }
@@ -73,10 +66,9 @@
     public class ExecShoveExpression : ShoveExpression<Expression>
     {
-        public ExecShoveExpression() : base("EXEC.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+            Eval(interpreter.ExecStack, interpreter.IntegerStack);
         }
     }
@@ -84,10 +76,9 @@
     public class CodeShoveExpression : ShoveExpression<Expression>
     {
-        public CodeShoveExpression() : base("CODE.SHOVE")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.SHOVE"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+            Eval(interpreter.CodeStack, interpreter.IntegerStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14398)
@@ -8,9 +8,6 @@
     /// </summary>
     /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class StackdepthExpression<T> : Expression
+    public abstract class StackdepthExpression<T> : StatelessExpression
     {
-        public StackdepthExpression(string stringRepresentation) : base(stringRepresentation)
-        { }
-
         public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false)
         {
@@ -28,10 +25,9 @@
     public class IntegerStackdepthExpression : StackdepthExpression<long>
     {
-        public IntegerStackdepthExpression() : base("INTEGER.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "INTEGER.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
+            Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
         }
     }
@@ -39,10 +35,9 @@
     public class FloatStackdepthExpression : StackdepthExpression<double>
     {
-        public FloatStackdepthExpression() : base("FLOAT.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "FLOAT.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+            Eval(interpreter.FloatStack, interpreter.IntegerStack);
         }
     }
@@ -50,10 +45,9 @@
     public class BooleanStackdepthExpression : StackdepthExpression<bool>
     {
-        public BooleanStackdepthExpression() : base("BOOLEAN.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "BOOLEAN.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
         }
     }
@@ -61,10 +55,9 @@
     public class NameStackdepthExpression : StackdepthExpression<string>
     {
-        public NameStackdepthExpression() : base("NAME.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "NAME.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+            Eval(interpreter.NameStack, interpreter.IntegerStack);
         }
     }
@@ -72,10 +65,9 @@
     public class ExecStackdepthExpression : StackdepthExpression<Expression>
     {
-        public ExecStackdepthExpression() : base("EXEC.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "EXEC.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+            Eval(interpreter.ExecStack, interpreter.IntegerStack);
         }
     }
@@ -83,10 +75,9 @@
     public class CodeStackdepthExpression : StackdepthExpression<Expression>
     {
-        public CodeStackdepthExpression() : base("CODE.STACKDEPTH")
-        { }
+        protected override string InitStringRepresentation() { return "CODE.STACKDEPTH"; }
 
         public override void Eval(IInterpreter interpreter)
         {
-            this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+            Eval(interpreter.CodeStack, interpreter.IntegerStack);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14398)
@@ -0,0 +1,13 @@
+﻿using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    public abstract class StatefullExpression : Expression
+    {
+        protected StatefullExpression()
+        { }
+
+        protected StatefullExpression(StatefullExpression origin, Cloner cloner) : base(origin, cloner)
+        { }
+    }
+}
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14398)
@@ -0,0 +1,17 @@
+﻿using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    public abstract class StatelessExpression : Expression
+    {
+        protected override int InitId()
+        {
+            return StringRepresentation.GetHashCode();
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return this;
+        }
+    }
+}
